/*
 * Seriaalinen eli peräkkäinen asynkronisten funktioiden suoritus
 * Apuna käytetty Nimble-moduulikirjastoa jonka avulla voidaan pakottaa
 * sekä peräkkäinen että rinnakkainen suoritus ja näiden yhdistelmät.
 */

const flow = require('nimble');

/*flow-olion series -metodilla funktiot laitetaan taulukkoon jossa ne
suoritetaan peräkkäin. Suoritettu callback tulee aina uuden funktion parametriksi.
Funktion suoritus laukaisee aina uuden funktion suorituksen joten suoritus on
peräkkäistä (serial flow)
*/

flow.series([
  function (callback) {
    setTimeout(function () {
      console.log('I execute first.');
      callback();
    }, 1000); //sekunnin viive
  },
  function (callback) {
    setTimeout(function () {
      console.log('I execute next.');
      callback();
    }, 500); //puolen sekunnin viive
  },
  function (callback) {
    setTimeout(function () {
      console.log('I execute last.');
      callback();
    }, 100); //sekunnin kymmenyksen viive
  },
]);

//Paralleelinen eli rinnakkaissuoritus onnistuu Nimblellä samalla tavalla.
//Tehdään vaan taulukko tyyliin flow.parallel([ ...ja funktiot tänne...]);
//Huomaa että funktioiden suoritusjärjestys kääntyy koska kaikkien suoritus
//alkaa yhtä aikaa
/*
flow.parallel([
    function (callback) {
        setTimeout(function () {
            console.log('I execute first.');
            callback();
        }, 1000);
    },
    function (callback) {
        setTimeout(function () {
            console.log('I execute next.');
            callback();
        }, 500);
    },
    function (callback) {
        setTimeout(function () {
            console.log('I execute last.');
            callback();
        }, 100);
    },
]);
*/

//Peräkkäisuoritus onnistuu näinkin, mutta sisäkkäisyys ei hyvä juttu
/*
setTimeout(function () {
    console.log('I execute first.');
    setTimeout(function () {
        console.log('I execute next.');
        setTimeout(function () {
            console.log('I execute last.');
        }, 100);
    }, 500);
}, 1000);
*/

//Näin homma ei onnistu
/*
setTimeout(function () {
            console.log('I execute first.');
        }, 1000);

setTimeout(function () {
            console.log('I execute next.');
        }, 500);

setTimeout(function () {
            console.log('I execute last.');
        }, 100);

*/
